searchNodes=[{"doc":"Snap is split into 3 main components: Snap.Cluster - clusters are wrappers around the Elasticsearch HTTP API. We can use this to perform low-level HTTP requests. Snap.Bulk - a convenience wrapper around bulk operations, using Stream to stream actions (such as Snap.Bulk.Action.Create ) to be performed against the Snap.Cluster . Snap.Indexes - a convenience wrapper around the Elasticsearch indexes APIs, allowing the creation, deleting and aliasing of indexes, along with hotswap functionality to bulk load documents into an aliased index, switching to it atomically. Additionally, there are other supporting modules: Snap.HTTPClient - defines how to send HTTP requests. Comes with a built in adapter for Finch ( Snap.HTTPClient.Adapters.Finch ) Snap.Auth - defines how an HTTP request is modified to include authentication headers. Snap.Auth.Plain implements HTTP Basic Auth. Set up Snap.Cluster is a wrapped around an Elasticsearch cluster. We can define it like so: defmodule MyApp.Cluster do use Snap.Cluster , otp_app : :my_app end The configuration for the cluster can be defined in your config: config :my_app , MyApp.Cluster , url : &quot;http://localhost:9200&quot; , username : &quot;username&quot; , password : &quot;password&quot; Or you can load it dynamically by implementing Snap.Cluster.init/1 . Each cluster defines start_link/1 which must be invoked before using the cluster and optionally accepts an explicit config. It creates the supervision tree, including the connection pool. Include it in your application: def start ( _type , _args ) do children = [ { MyApp.Cluster , [ ] } ] opts = [ strategy : :one_for_one , name : MyApp.Supervisor ] Supervisor . start_link ( children , opts ) end Config The following configuration options are supported: url - the URL of the Elasticsearch HTTP endpoint (required) username - the username used to access the cluster password - the password used to access the cluster auth - the auth module used to configure the HTTP authentication headers (defaults to Snap.Auth.Plain ) http_client_adapter - the adapter that will be used to send HTTP requests. Check Snap.HTTPClient for more information. (defaults to Snap.HTTPClient.Adapters.Finch ) telemetry_prefix - the prefix of the telemetry events (defaults to [:my_app, :snap] ) Telemetry Snap supports sending Telemetry events on each HTTP request. It sends one event per query, of the name [:my_app, :snap, :request] . The telemetry event has the following measurements: response_time - how long the request took to return decode_time - how long the response took to decode into a map or exception total_time - how long everything took in total In addition, the metadata contains a map of: method - the HTTP method used path - the path requested port - the port requested host - the host requested headers - a list of the headers sent body - the body sent result - the result returned to the user","ref":"Snap.html","title":"Snap","type":"module"},{"doc":"Represents an individual aggregation dictionary from a Search Aggregation API response.","ref":"Snap.Aggregation.html","title":"Snap.Aggregation","type":"module"},{"doc":"","ref":"Snap.Aggregation.html#new/1","title":"Snap.Aggregation.new/1","type":"function"},{"doc":"","ref":"Snap.Aggregation.html#t:t/0","title":"Snap.Aggregation.t/0","type":"type"},{"doc":"Supports streaming bulk operations against a Snap.Cluster .","ref":"Snap.Bulk.html","title":"Snap.Bulk","type":"module"},{"doc":"Performs a bulk operation. Takes an Enumerable of action structs, where each struct is one of: Snap.Bulk.Action.Create Snap.Bulk.Action.Index Snap.Bulk.Action.Update Snap.Bulk.Action.Delete actions = [ % Snap.Bulk.Action.Create { _id : 1 , doc : %{ foo : &quot;bar&quot; } } , % Snap.Bulk.Action.Create { _id : 2 , doc : %{ foo : &quot;bar&quot; } } , % Snap.Bulk.Action.Create { _id : 3 , doc : %{ foo : &quot;bar&quot; } } ] actions |&gt; Snap.Bulk . perform ( Cluster , &quot;index&quot; ) It chunks the Enumerable into pages, and pauses between pages for Elasticsearch to catch up. Uses Stream under the hood, so you can lazily feed it a stream of actions, such as out of an Ecto.Repo to bulk load documents from an SQL database. If no errors occur on any page it returns :ok . If any errors occur, on any page, it returns {:error, %Snap.BulkError{}} , containing a list of the errors. It will continue to the end of the stream, even if errors occur. Options: page_size - defines the size of each page, defaulting to 5000 actions. page_wait - defines wait period between pages in ms, defaulting to 15000ms. max_errors - aborts when the number of errors returned exceedes this count (defaults to nil , which will run to the end) request_opts - defines the options to be used with Snap.Request Any other options, such as pipeline: &quot;foo&quot; are passed through as query parameters to the Bulk API endpoint.","ref":"Snap.Bulk.html#perform/4","title":"Snap.Bulk.perform/4","type":"function"},{"doc":"Defines a cluster. A cluster maps to an Elasticsearch endpoint. When used, the cluster expects :otp_app as an option. The :otp_app should point to an OTP application that has the cluster configuration. For example, this cluster: defmodule MyApp.Cluster do use Snap.Cluster , otp_app : :my_app end Can be configured with: config :my_app , MyApp.Cluster , url : &quot;http://localhost:9200&quot; , username : &quot;username&quot; , password : &quot;password&quot;","ref":"Snap.Cluster.html","title":"Snap.Cluster","type":"behaviour"},{"doc":"Returns the config in use by this cluster.","ref":"Snap.Cluster.html#c:config/0","title":"Snap.Cluster.config/0","type":"callback"},{"doc":"Sends a DELETE request. Returns either: {:ok, response} - where response is a map representing the parsed JSON response. {:error, error} - where the error can be a struct of either: Snap.ResponseError Snap.HTTPClient.Error Jason.DecodeError","ref":"Snap.Cluster.html#c:delete/4","title":"Snap.Cluster.delete/4","type":"callback"},{"doc":"Sends a GET request. Returns either: {:ok, response} - where response is a map representing the parsed JSON response. {:error, error} - where the error can be a struct of either: Snap.ResponseError Snap.HTTPClient.Error Jason.DecodeError","ref":"Snap.Cluster.html#c:get/4","title":"Snap.Cluster.get/4","type":"callback"},{"doc":"Sets up the config for the cluster. Override this to dynamically load a config from somewhere other than your application config.","ref":"Snap.Cluster.html#c:init/1","title":"Snap.Cluster.init/1","type":"callback"},{"doc":"Sends a POST request. Returns either: {:ok, response} - where response is a map representing the parsed JSON response. {:error, error} - where the error can be a struct of either: Snap.ResponseError Snap.HTTPClient.Error Jason.DecodeError","ref":"Snap.Cluster.html#c:post/5","title":"Snap.Cluster.post/5","type":"callback"},{"doc":"Sends a PUT request. Returns either: {:ok, response} - where response is a map representing the parsed JSON response. {:error, error} - where the error can be a struct of either: Snap.ResponseError Snap.HTTPClient.Error Jason.DecodeError","ref":"Snap.Cluster.html#c:put/5","title":"Snap.Cluster.put/5","type":"callback"},{"doc":"The body of the HTTP request","ref":"Snap.Cluster.html#t:body/0","title":"Snap.Cluster.body/0","type":"type"},{"doc":"Options available for configuring the Cluster","ref":"Snap.Cluster.html#t:config_opts/0","title":"Snap.Cluster.config_opts/0","type":"type"},{"doc":"An error from an HTTP operation","ref":"Snap.Cluster.html#t:error/0","title":"Snap.Cluster.error/0","type":"type"},{"doc":"Any additional HTTP headers sent with the request","ref":"Snap.Cluster.html#t:headers/0","title":"Snap.Cluster.headers/0","type":"type"},{"doc":"Options passed through to the request","ref":"Snap.Cluster.html#t:opts/0","title":"Snap.Cluster.opts/0","type":"type"},{"doc":"The query params, which will be appended to the path","ref":"Snap.Cluster.html#t:params/0","title":"Snap.Cluster.params/0","type":"type"},{"doc":"The path of the HTTP endpoint","ref":"Snap.Cluster.html#t:path/0","title":"Snap.Cluster.path/0","type":"type"},{"doc":"The result from an HTTP operation","ref":"Snap.Cluster.html#t:result/0","title":"Snap.Cluster.result/0","type":"type"},{"doc":"A successful results from an HTTP operation","ref":"Snap.Cluster.html#t:success/0","title":"Snap.Cluster.success/0","type":"type"},{"doc":"Response of a http request.","ref":"Snap.HTTPClient.Response.html","title":"Snap.HTTPClient.Response","type":"module"},{"doc":"","ref":"Snap.HTTPClient.Response.html#t:status/0","title":"Snap.HTTPClient.Response.status/0","type":"type"},{"doc":"","ref":"Snap.HTTPClient.Response.html#t:t/0","title":"Snap.HTTPClient.Response.t/0","type":"type"},{"doc":"Represents an HTTP error returned while executing a query.","ref":"Snap.HTTPError.html","title":"Snap.HTTPError","type":"exception"},{"doc":"","ref":"Snap.HTTPError.html#exception_from_response/1","title":"Snap.HTTPError.exception_from_response/1","type":"function"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Snap.HTTPError.html#message/1","title":"Snap.HTTPError.message/1","type":"function"},{"doc":"Helper functions around index management.","ref":"Snap.Indexes.html","title":"Snap.Indexes","type":"module"},{"doc":"Creates an alias for a versioned index, removing any existing aliases.","ref":"Snap.Indexes.html#alias/4","title":"Snap.Indexes.alias/4","type":"function"},{"doc":"Deletes older timestamped indexes.","ref":"Snap.Indexes.html#cleanup/4","title":"Snap.Indexes.cleanup/4","type":"function"},{"doc":"Creates an index.","ref":"Snap.Indexes.html#create/4","title":"Snap.Indexes.create/4","type":"function"},{"doc":"Deletes an index.","ref":"Snap.Indexes.html#delete/3","title":"Snap.Indexes.delete/3","type":"function"},{"doc":"Creates and loads a new index, switching the alias to it with zero-downtime. Takes an Enumerable of Snap.Bulk actions, and builds a new index from it. Refreshes it, updates the alias to it, and cleans up the old indexes, leaving the previous one behind. May return Snap.Cluster.error/0 or a Snap.BulkError containing a list of failed bulk actions.","ref":"Snap.Indexes.html#hotswap/5","title":"Snap.Indexes.hotswap/5","type":"function"},{"doc":"Lists all the indexes in the cluster.","ref":"Snap.Indexes.html#list/2","title":"Snap.Indexes.list/2","type":"function"},{"doc":"Lists all the timestamp versioned indexes starting with the prefix.","ref":"Snap.Indexes.html#list_starting_with/3","title":"Snap.Indexes.list_starting_with/3","type":"function"},{"doc":"Refreshes an index.","ref":"Snap.Indexes.html#refresh/3","title":"Snap.Indexes.refresh/3","type":"function"},{"doc":"Performs searches against an ElasticSearch cluster.","ref":"Snap.Search.html","title":"Snap.Search","type":"module"},{"doc":"Makes a search against an ElasticSearch cluster and parses the response. Performs a search against an index using a POST request, and parses the response into a Snap.SearchResponse . Snap.SearchResponse implements Enumerable , so you can count and iterate directly on the struct. Examples query = %{ query : %{ match_all : %{ } } } { :ok , response } = Snap.Search . search ( Cluster , &quot;index&quot; , query ) IO . inspect ( response . took ) Enum . each ( response , fn hit -&gt; IO . inspect ( hit . score ) end )","ref":"Snap.Search.html#search/6","title":"Snap.Search.search/6","type":"function"},{"doc":"Represents an individual suggest dictionary from a Search API response.","ref":"Snap.Suggest.html","title":"Snap.Suggest","type":"module"},{"doc":"","ref":"Snap.Suggest.html#new/1","title":"Snap.Suggest.new/1","type":"function"},{"doc":"","ref":"Snap.Suggest.html#t:t/0","title":"Snap.Suggest.t/0","type":"type"},{"doc":"Represents an individual suggest / options dictionary from a Search API response.","ref":"Snap.Suggest.Option.html","title":"Snap.Suggest.Option","type":"module"},{"doc":"","ref":"Snap.Suggest.Option.html#new/1","title":"Snap.Suggest.Option.new/1","type":"function"},{"doc":"","ref":"Snap.Suggest.Option.html#t:t/0","title":"Snap.Suggest.Option.t/0","type":"type"},{"doc":"Represents the suggest / options dictionary returned from an ElasticSearch Search API response.","ref":"Snap.Suggest.Options.html","title":"Snap.Suggest.Options","type":"module"},{"doc":"","ref":"Snap.Suggest.Options.html#new/1","title":"Snap.Suggest.Options.new/1","type":"function"},{"doc":"","ref":"Snap.Suggest.Options.html#t:t/0","title":"Snap.Suggest.Options.t/0","type":"type"},{"doc":"Represents the suggest dictionary returned from an ElasticSearch Search API response.","ref":"Snap.Suggests.html","title":"Snap.Suggests","type":"module"},{"doc":"","ref":"Snap.Suggests.html#new/1","title":"Snap.Suggests.new/1","type":"function"},{"doc":"","ref":"Snap.Suggests.html#t:t/0","title":"Snap.Suggests.t/0","type":"type"},{"doc":"Defines how HTTP request is transformed to add authentication.","ref":"Snap.Auth.html","title":"Snap.Auth","type":"behaviour"},{"doc":"Modifies an HTTP request to include authentication details","ref":"Snap.Auth.html#c:sign/5","title":"Snap.Auth.sign/5","type":"callback"},{"doc":"","ref":"Snap.Auth.html#t:response/0","title":"Snap.Auth.response/0","type":"type"},{"doc":"","ref":"Snap.Auth.html#t:t/0","title":"Snap.Auth.t/0","type":"type"},{"doc":"Implements HTTP Basic Auth, if necessary. If the cluster config defines a username and password, an Authorization: Basic header is added to the request. config :my_app , MyApp.Cluster , url : &quot;http://localhost:9200&quot; , username : &quot;foo&quot; , password : &quot; bar Or you can define a username and password in the URL itself: config :my_app , MyApp.Cluster , url : &quot;http://username:password@localhost:9200&quot; If no username or password is defined, no Authorization header is added, making it suitable for local development.","ref":"Snap.Auth.Plain.html","title":"Snap.Auth.Plain","type":"module"},{"doc":"Callback implementation for Snap.Auth.sign/5 .","ref":"Snap.Auth.Plain.html#sign/5","title":"Snap.Auth.Plain.sign/5","type":"function"},{"doc":"Behaviour for the HTTP client used by the Snap.Cluster . By default, it uses the Snap.HTTPClient.Adapters.Finch for making requests. You can configure the Cluster with your own adapter: config :my_app , MyApp.Cluster , http_client_adapter : MyHTTPClientAdapter The adapter can be configured passing a tuple: config :my_app , MyApp.Cluster , http_client_adapter : { MyHTTPClientAdapter , some_config_for_adapter : &quot;config_value&quot; }","ref":"Snap.HTTPClient.html","title":"Snap.HTTPClient","type":"behaviour"},{"doc":"","ref":"Snap.HTTPClient.html#child_spec/1","title":"Snap.HTTPClient.child_spec/1","type":"function"},{"doc":"Returns a specification to start this module under the Snap supervisor tree. If the adapter doesn't need to start in the supervisor tree, you can return :skip .","ref":"Snap.HTTPClient.html#c:child_spec/1","title":"Snap.HTTPClient.child_spec/1","type":"callback"},{"doc":"","ref":"Snap.HTTPClient.html#request/6","title":"Snap.HTTPClient.request/6","type":"function"},{"doc":"Executes the request with the configured adapter.","ref":"Snap.HTTPClient.html#c:request/6","title":"Snap.HTTPClient.request/6","type":"callback"},{"doc":"","ref":"Snap.HTTPClient.html#t:body/0","title":"Snap.HTTPClient.body/0","type":"type"},{"doc":"","ref":"Snap.HTTPClient.html#t:child_spec/0","title":"Snap.HTTPClient.child_spec/0","type":"type"},{"doc":"","ref":"Snap.HTTPClient.html#t:headers/0","title":"Snap.HTTPClient.headers/0","type":"type"},{"doc":"","ref":"Snap.HTTPClient.html#t:method/0","title":"Snap.HTTPClient.method/0","type":"type"},{"doc":"","ref":"Snap.HTTPClient.html#t:t/0","title":"Snap.HTTPClient.t/0","type":"type"},{"doc":"","ref":"Snap.HTTPClient.html#t:url/0","title":"Snap.HTTPClient.url/0","type":"type"},{"doc":"Built in adapter using Finch . You can also configure this adapter by explicitly setting the http_client_adapter in the Snap.Cluster configuration with a tuple {Snap.HTTPClient.Adapters.Finch, config} . For example: config :my_app , MyApp.Cluster , http_client_adapter : { Snap.HTTPClient.Adapters.Finch , pool_size : 20 } You can check the config/0 for docs about the available configurations.","ref":"Snap.HTTPClient.Adapters.Finch.html","title":"Snap.HTTPClient.Adapters.Finch","type":"module"},{"doc":"Available options for configuring the Finch adapter. For more information about the options, you can check Finch's official docs . pool_size : Set the pool size. Defaults to 5 . conn_opts : Connection options passed to Mint.HTTP.connect/4 . Defaults to [] .","ref":"Snap.HTTPClient.Adapters.Finch.html#t:config/0","title":"Snap.HTTPClient.Adapters.Finch.config/0","type":"type"},{"doc":"Represents a create step in a Snap.Bulk operation","ref":"Snap.Bulk.Action.Create.html","title":"Snap.Bulk.Action.Create","type":"module"},{"doc":"","ref":"Snap.Bulk.Action.Create.html#t:t/0","title":"Snap.Bulk.Action.Create.t/0","type":"type"},{"doc":"Represents a delete step in a Snap.Bulk operation","ref":"Snap.Bulk.Action.Delete.html","title":"Snap.Bulk.Action.Delete","type":"module"},{"doc":"","ref":"Snap.Bulk.Action.Delete.html#t:t/0","title":"Snap.Bulk.Action.Delete.t/0","type":"type"},{"doc":"Represents an index step in a Snap.Bulk operation","ref":"Snap.Bulk.Action.Index.html","title":"Snap.Bulk.Action.Index","type":"module"},{"doc":"","ref":"Snap.Bulk.Action.Index.html#t:t/0","title":"Snap.Bulk.Action.Index.t/0","type":"type"},{"doc":"Represents an update step in a Snap.Bulk operation","ref":"Snap.Bulk.Action.Update.html","title":"Snap.Bulk.Action.Update","type":"module"},{"doc":"","ref":"Snap.Bulk.Action.Update.html#t:t/0","title":"Snap.Bulk.Action.Update.t/0","type":"type"},{"doc":"Represents an individual hit dictionary from a Search API response.","ref":"Snap.Hit.html","title":"Snap.Hit","type":"module"},{"doc":"","ref":"Snap.Hit.html#new/1","title":"Snap.Hit.new/1","type":"function"},{"doc":"","ref":"Snap.Hit.html#t:t/0","title":"Snap.Hit.t/0","type":"type"},{"doc":"Represents the hits dictionary returned from an ElasticSearch Search API response. Implements Enumerable , so you can iterate directly over the struct.","ref":"Snap.Hits.html","title":"Snap.Hits","type":"module"},{"doc":"","ref":"Snap.Hits.html#new/1","title":"Snap.Hits.new/1","type":"function"},{"doc":"","ref":"Snap.Hits.html#t:t/0","title":"Snap.Hits.t/0","type":"type"},{"doc":"Represents the response from ElasticSearch's Search API . Implements Enumerable , so you can iterate directly over the struct.","ref":"Snap.SearchResponse.html","title":"Snap.SearchResponse","type":"module"},{"doc":"","ref":"Snap.SearchResponse.html#build_aggregations/1","title":"Snap.SearchResponse.build_aggregations/1","type":"function"},{"doc":"","ref":"Snap.SearchResponse.html#new/1","title":"Snap.SearchResponse.new/1","type":"function"},{"doc":"","ref":"Snap.SearchResponse.html#t:t/0","title":"Snap.SearchResponse.t/0","type":"type"},{"doc":"Represents a list of errors, collected from a Snap.Bulk operation.","ref":"Snap.BulkError.html","title":"Snap.BulkError","type":"exception"},{"doc":"","ref":"Snap.BulkError.html#t:t/0","title":"Snap.BulkError.t/0","type":"type"},{"doc":"Represents an Error returned by the HTTPClient. Usually this wraps an error coming from the adapter that implements the Snap.HTTPClient behaviour, such as Mint.HTTPError . Struct Fields :reason - the error reason represented by an atom. :origin - the origin of the error. Contains the original error coming from the adapter of the Snap.HTTPClient behaviour, such as Mint.HTTPError or Mint.TransportError .","ref":"Snap.HTTPClient.Error.html","title":"Snap.HTTPClient.Error","type":"exception"},{"doc":"","ref":"Snap.HTTPClient.Error.html#new/2","title":"Snap.HTTPClient.Error.new/2","type":"function"},{"doc":"","ref":"Snap.HTTPClient.Error.html#unknown/1","title":"Snap.HTTPClient.Error.unknown/1","type":"function"},{"doc":"","ref":"Snap.HTTPClient.Error.html#t:t/0","title":"Snap.HTTPClient.Error.t/0","type":"type"},{"doc":"Represents an Elasticsearch exception raised while executing a query.","ref":"Snap.ResponseError.html","title":"Snap.ResponseError","type":"exception"},{"doc":"","ref":"Snap.ResponseError.html#exception_from_json/1","title":"Snap.ResponseError.exception_from_json/1","type":"function"},{"doc":"","ref":"Snap.ResponseError.html#t:t/0","title":"Snap.ResponseError.t/0","type":"type"}]